---
title: AudioWorkletNode
slug: Web/API/AudioWorkletNode
tags:
  - API
  - Audio
  - AudioWorkletNode
  - Experimental
  - Interface
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<div class="blockIndicator secureContexts">Although the interface is available outside <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a>, the {{domxref("BaseAudioContext.audioWorklet")}} property is not, thus custom {{domxref("AudioWorkletProcessor")}}s cannot be defined outside them.</div>

<p>The <strong><code>AudioWorkletNode</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a> represents a base class for a user-defined {{domxref("AudioNode")}}, which can be connected to an audio routing graph along with other nodes. It has an associated {{domxref("AudioWorkletProcessor")}}, which does the actual audio processing in a Web Audio rendering thread.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("AudioWorkletNode.AudioWorkletNode", "AudioWorkletNode()")}}</dt>
 <dd>Creates a new instance of an <code>AudioWorkletNode</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Also Inherits properties from its parent, {{domxref("AudioNode")}}</em>.</p>

<dl>
 <dt>{{domxref("AudioWorkletNode.port")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("MessagePort")}} used for bidirectional communication between the node and its associated {{domxref("AudioWorkletProcessor")}}. The other end is available under the {{domxref("AudioWorkletProcessor.port", "port")}} property of the processor.</dd>
 <dt>{{domxref("AudioWorkletNode.parameters")}} {{readonlyinline}}</dt>
 <dd>Returns an {{domxref("AudioParamMap")}} — a collection of {{domxref("AudioParam")}} objects. They are instantiated during the creation of the underlying <code>AudioWorkletProcessor</code>. If the <code>AudioWorkletProcessor</code> has a static {{domxref("AudioWorkletProcessor.parameterDescriptors", "parameterDescriptors")}} getter, the {{domxref("AudioParamDescriptor")}} array returned from it is used to create <code>AudioParam</code> objects on the <code>AudioWorkletNode</code>. With this mechanism it is possible to make your own <code>AudioParam</code> objects accessible from your <code>AudioWorkletNode</code>. You can then use their values in the associated <code>AudioWorkletProcessor</code>.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("AudioWorkletNode.onprocessorerror")}}</dt>
 <dd>Fired when an error is thrown in associated {{domxref("AudioWorkletProcessor")}}. Once fired, the processor and consequently the node will output silence throughout its lifetime.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Also inherits methods from its parent, </em><em>{{domxref("AudioNode")}}</em>.</p>

<p><em>The <code>AudioWorkletNode</code> interface does not define any methods of its own.</em></p>

<h2 id="Examples">Examples</h2>

<p>In this example we create a custom <code>AudioWorkletNode</code> that outputs white noise.</p>

<p>First, we need to define a custom {{domxref("AudioWorkletProcessor")}}, which will output white noise, and register it. Note that this should be done in a separate file.</p>

<pre class="brush: js">// white-noise-processor.js
class WhiteNoiseProcessor extends AudioWorkletProcessor {
  process (inputs, outputs, parameters) {
    const output = outputs[0]
    output.forEach(channel =&gt; {
      for (let i = 0; i &lt; channel.length; i++) {
        channel[i] = Math.random() * 2 - 1
      }
    })
    return true
  }
}

registerProcessor('white-noise-processor', WhiteNoiseProcessor)
</pre>

<p>Next, in our main script file we'll load the processor, create an instance of <code>AudioWorkletNode</code> passing it the name of the processor, and connect the node to an audio graph.</p>

<pre class="brush: js">const audioContext = new AudioContext()
await audioContext.audioWorklet.addModule('white-noise-processor.js')
const whiteNoiseNode = new AudioWorkletNode(audioContext, 'white-noise-processor')
whiteNoiseNode.connect(audioContext.destination)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#audioworkletnode', 'AudioWorkletNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioWorkletNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
